Panda3D

Classes | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
PGItem Class Reference

This is the base class for all the various kinds of gui widget objects. More...

`#include "pgItem.h"`

Inheritance diagram for PGItem:

## Public Member Functions
| PGItem (const std::string &name)
virtual void | candidate (const MouseWatcherParameter &param, bool background)
| This is a callback hook function, called whenever the user highlights an option in the IME window. More...
void | clear_frame ()
| Removes the bounding rectangle from the item. More...
void | clear_state_def (int state)
| Resets the NodePath assigned to the indicated state to its initial default, with only a frame representation if appropriate. More...
virtual void | enter_region (const MouseWatcherParameter &param)
| This is a callback hook function, called whenever the mouse enters the region. More...
virtual void | exit_region (const MouseWatcherParameter &param)
| This is a callback hook function, called whenever the mouse exits the region. More...
virtual void | focus_in ()
| This is a callback hook function, called whenever the widget gets the keyboard focus. More...
virtual void | focus_out ()
| This is a callback hook function, called whenever the widget loses the keyboard focus. More...
virtual TypeHandle | force_init_type ()
bool | get_active () const
| Returns whether the PGItem is currently active for mouse events. More...
bool | get_background_focus () const
| Returns whether background_focus is currently enabled. More...
std::string | get_enter_event () const
| Returns the event name that will be thrown when the item is active and the mouse enters its frame, but not any nested frames. More...
std::string | get_exit_event () const
| Returns the event name that will be thrown when the item is active and the mouse exits its frame, or enters a nested frame. More...
bool | get_focus () const
| Returns whether the PGItem currently has focus for keyboard events. More...
std::string | get_focus_in_event () const
| Returns the event name that will be thrown when the item gets the keyboard focus. More...
std::string | get_focus_out_event () const
| Returns the event name that will be thrown when the item loses the keyboard focus. More...
const LVecBase4 & | get_frame () const
| Returns the bounding rectangle of the item. More...
LMatrix4 | get_frame_inv_xform () const
| Returns the inverse of the frame transform matrix. More...
PGFrameStyle | get_frame_style (int state)
| Returns the kind of frame that will be drawn behind the item when it is in the indicated state. More...
const std::string & | get_id () const
| Returns the unique ID assigned to this PGItem. More...
std::string | get_keystroke_event () const
| Returns the event name that will be thrown when the item is active and any key is pressed by the user. More...
PGItemNotify * | get_notify () const
| Returns the object which will be notified when the PGItem changes, if any. More...
int | get_num_state_defs () const
std::string | get_press_event (const ButtonHandle &button) const
| Returns the event name that will be thrown when the item is active and the indicated mouse or keyboard button is depressed while the mouse is within the frame. More...
PGMouseWatcherRegion * | get_region () const
| Returns the MouseWatcherRegion associated with this item. More...
std::string | get_release_event (const ButtonHandle &button) const
| Returns the event name that will be thrown when the item is active and the indicated mouse or keyboard button, formerly clicked down is within the frame, is released. More...
std::string | get_repeat_event (const ButtonHandle &button) const
| Returns the event name that will be thrown when the item is active and the indicated mouse or keyboard button is continuously held down while the mouse is within the frame. More...
int | get_state () const
| Returns the "state" of this particular PGItem. More...
NodePath & | get_state_def (int state)
int | get_suppress_flags () const
| This is just an interface to get the suppress flags on the underlying MouseWatcherRegion. More...
virtual TypeHandle | get_type () const
std::string | get_within_event () const
| Returns the event name that will be thrown when the item is active and the mouse moves within the boundaries of the frame. More...
std::string | get_without_event () const
| Returns the event name that will be thrown when the item is active and the mouse moves completely outside the boundaries of the frame. More...
bool | has_frame () const
| Returns true if the item has a bounding rectangle; see set_frame(). More...
bool | has_notify () const
| Returns true if there is an object configured to be notified when the PGItem changes, false otherwise. More...
bool | has_state_def (int state) const
| Returns true if get_state_def() has ever been called for the indicated state (thus defining a render subgraph for this state index), false otherwise. More...
NodePath | instance_to_state_def (int state, const NodePath &path)
| Parents an instance of the bottom node of the indicated NodePath to the indicated state index. More...
virtual void | keystroke (const MouseWatcherParameter &param, bool background)
| This is a callback hook function, called whenever the user presses a key. More...
virtual void | move (const MouseWatcherParameter &param)
| This is a callback hook function, called whenever a mouse is moved while within the region. More...
virtual void | press (const MouseWatcherParameter &param, bool background)
| This is a callback hook function, called whenever a mouse or keyboard button is depressed while the mouse is within the region. More...
virtual void | release (const MouseWatcherParameter &param, bool background)
| This is a callback hook function, called whenever a mouse or keyboard button previously depressed with press() is released. More...
virtual void | set_active (bool active)
| Sets whether the PGItem is active for mouse watching. More...
void | set_background_focus (bool focus)
| Sets the background_focus flag for this item. More...
virtual void | set_focus (bool focus)
| Sets whether the PGItem currently has keyboard focus. More...
void | set_frame (const LVecBase4 &frame)
| Sets the bounding rectangle of the item, in local coordinates. More...
void | set_frame (PN_stdfloat left, PN_stdfloat right, PN_stdfloat bottom, PN_stdfloat top)
| Sets the bounding rectangle of the item, in local coordinates. More...
void | set_frame_style (int state, const PGFrameStyle &style)
| Changes the kind of frame that will be drawn behind the item when it is in the indicated state. More...
void | set_id (const std::string &id)
| Set the unique ID assigned to this PGItem. More...
void | set_name (const std::string &name)
void | set_notify (PGItemNotify *notify)
| Sets the object which will be notified when the PGItem changes. More...
void | set_state (int state)
| Sets the "state" of this particular PGItem. More...
void | set_suppress_flags (int suppress_flags)
| This is just an interface to set the suppress flags on the underlying MouseWatcherRegion. More...
virtual void | within_region (const MouseWatcherParameter &param)
| This is a callback hook function, called whenever the mouse moves within the boundaries of the region, even if it is also within the boundaries of a nested region. More...
virtual void | without_region (const MouseWatcherParameter &param)
| This is a callback hook function, called whenever the mouse moves completely outside the boundaries of the region. More...
Public Member Functions inherited from PandaNode
| PandaNode (const std::string &name)
void | add_child (PandaNode *child_node, int sort=0, Thread *current_thread=Thread::get_current_thread())
virtual void | add_for_draw (CullTraverser *trav, CullTraverserData &data)
| Adds the node's contents to the CullResult we are building up during the cull traversal, so that it will be drawn at render time. More...
void | add_stashed (PandaNode *child_node, int sort=0, Thread *current_thread=Thread::get_current_thread())
| Adds a new child to the node, directly as a stashed child. More...
void | adjust_draw_mask (DrawMask show_mask, DrawMask hide_mask, DrawMask clear_mask)
| Adjusts the hide/show bits of this particular node. More...
virtual void | apply_attribs_to_vertices (const AccumulatedAttribs &attribs, int attrib_types, GeomTransformer &transformer)
| Applies whatever attributes are specified in the AccumulatedAttribs object (and by the attrib_types bitmask) to the vertices on this node, if appropriate. More...
virtual Light * | as_light ()
| Cross-casts the node to a Light pointer, if it is one of the four kinds of Light nodes, or returns NULL if it is not. More...
void | clear_attrib (int slot)
| Removes the render attribute of the given type from this node. More...
void | clear_attrib (TypeHandle type)
void | clear_bounds ()
| Reverses the effect of a previous call to set_bounds(), and allows the node's bounding volume to be automatically computed once more based on the contents of the node. More...
void | clear_effect (TypeHandle type)
| Removes the render effect of the given type from this node. More...
void | clear_effects (Thread *current_thread=Thread::get_current_thread())
void | clear_state (Thread *current_thread=Thread::get_current_thread())
void | clear_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread())
void | clear_transform (Thread *current_thread=Thread::get_current_thread())
void | clear_unexpected_change (unsigned int flags)
| Sets one or more of the PandaNode::UnexpectedChange bits off, indicating that the corresponding property may once again change on this node. More...
virtual PandaNode * | combine_with (PandaNode *other)
| Collapses this PandaNode with the other PandaNode, if possible, and returns a pointer to the combined PandaNode, or NULL if the two PandaNodes cannot safely be combined. More...
int | compare_tags (const PandaNode *other) const
| Returns a number less than 0, 0, or greater than 0, to indicate the similarity of tags between this node and the other one. More...
void | copy_all_properties (PandaNode *other)
| Copies the TransformState, RenderState, RenderEffects, tags, Python tags, and the show/hide state from the other node onto this one. More...
void | copy_children (PandaNode *other, Thread *current_thread=Thread::get_current_thread())
| Makes another instance of all the children of the other node, copying them to this node. More...
void | copy_tags (PandaNode *other)
| Copies all of the tags stored on the other node onto this node. More...
int | count_num_descendants () const
| CPT (BoundingVolume) get_bounds(Thread *current_thread
| CPT (BoundingVolume) get_bounds(UpdateSeq &seq
| CPT (BoundingVolume) get_internal_bounds(Thread *current_thread
| CPT (RenderAttrib) get_attrib(int slot) const
| CPT (RenderAttrib) get_attrib(TypeHandle type) const
| CPT (RenderAttrib) get_off_clip_planes(Thread *current_thread
| CPT (RenderEffect) get_effect(TypeHandle type) const
| CPT (RenderEffects) get_effects(Thread *current_thread
| CPT (RenderState) get_state(Thread *current_thread
virtual | CPT (TransformState) calc_tight_bounds(LPoint3 &min_point
| CPT (TransformState) get_prev_transform(Thread *current_thread
| CPT (TransformState) get_transform(Thread *current_thread
virtual PandaNode * | dupe_for_flatten () const
| This is similar to make_copy(), but it makes a copy for the specific purpose of flatten. More...
int | find_child (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated child node, if it is a child, or -1 if it is not. More...
int | find_parent (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated parent node, if it is a parent, or -1 if it is not. More...
int | find_stashed (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated stashed node, if it is a stashed child, or -1 if it is not. More...
BoundingVolume::BoundsType | get_bounds_type () const
PandaNode * | get_child (int n, Thread *current_thread=Thread::get_current_thread()) const
int | get_child_sort (int n, Thread *current_thread=Thread::get_current_thread()) const
| Returns the sort index of the nth child node of this node (that is, the number that was passed to add_child()). More...
Children | get_children (Thread *current_thread=Thread::get_current_thread()) const
DrawMask | get_draw_control_mask () const
DrawMask | get_draw_show_mask () const
int | get_fancy_bits (Thread *current_thread=Thread::get_current_thread()) const
| Returns the union of all of the enum FancyBits values corresponding to the various "fancy" attributes that are set on the node. More...
virtual int | get_first_visible_child () const
| Returns the index number of the first visible child of this node, or a number >= get_num_children() if there are no visible children of this node. More...
int | get_internal_vertices (Thread *current_thread=Thread::get_current_thread()) const
CollideMask | get_into_collide_mask () const
virtual CollideMask | get_legal_collide_mask () const
int | get_nested_vertices (Thread *current_thread=Thread::get_current_thread()) const
CollideMask | get_net_collide_mask (Thread *current_thread=Thread::get_current_thread()) const
| Returns the union of all into_collide_mask() values set at CollisionNodes at this level and below. More...
DrawMask | get_net_draw_control_mask () const
| Returns the set of bits in get_net_draw_show_mask() that have been explicitly set via adjust_draw_mask(), rather than implicitly inherited. More...
DrawMask | get_net_draw_show_mask () const
| Returns the union of all draw_show_mask values–of renderable nodes only– at this level and below. More...
virtual int | get_next_visible_child (int n) const
| Returns the index number of the next visible child of this node following the indicated child, or a number >= get_num_children() if there are no more visible children of this node. More...
int | get_num_children (Thread *current_thread=Thread::get_current_thread()) const
int | get_num_parents (Thread *current_thread=Thread::get_current_thread()) const
int | get_num_stashed (Thread *current_thread=Thread::get_current_thread()) const
size_t | get_num_tags () const
PandaNode * | get_parent (int n, Thread *current_thread=Thread::get_current_thread()) const
Parents | get_parents (Thread *current_thread=Thread::get_current_thread()) const
PandaNode * | get_stashed (int n, Thread *current_thread=Thread::get_current_thread()) const
Stashed | get_stashed (Thread *current_thread=Thread::get_current_thread()) const
int | get_stashed_sort (int n, Thread *current_thread=Thread::get_current_thread()) const
| Returns the sort index of the nth stashed node of this node (that is, the number that was passed to add_child()). More...
std::string | get_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread()) const
std::string | get_tag_key (size_t i) const
void | get_tag_keys (vector_string &keys) const
| Fills the given vector up with the list of tags on this PandaNode. More...
unsigned int | get_unexpected_change (unsigned int flags) const
| Returns nonzero if any of the bits in the input parameter are set on this node, or zero if none of them are set. More...
virtual int | get_unsafe_to_apply_attribs () const
| Returns the union of all attributes from SceneGraphReducer::AttribTypes that may not safely be applied to the vertices of this node. More...
virtual int | get_visible_child () const
| Returns the index number of the currently visible child of this node. More...
bool | has_attrib (int slot) const
bool | has_attrib (TypeHandle type) const
bool | has_dirty_prev_transform () const
bool | has_effect (TypeHandle type) const
virtual bool | has_selective_visibility () const
| Should be overridden by derived classes to return true if this kind of node has some restrictions on the set of children that should be rendered. More...
virtual bool | has_single_child_visibility () const
| Should be overridden by derived classes to return true if this kind of node has the special property that just one of its children is visible at any given time, and furthermore that the particular visible child can be determined without reference to any external information (such as a camera). More...
bool | has_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread()) const
bool | has_tags () const
virtual bool | is_ambient_light () const
| Returns true if this is an AmbientLight, false if it is not a light, or it is some other kind of light. More...
bool | is_bounds_stale () const
virtual bool | is_collision_node () const
| A simple downcast check. More...
bool | is_final (Thread *current_thread=Thread::get_current_thread()) const
virtual bool | is_geom_node () const
| A simple downcast check. More...
virtual bool | is_lod_node () const
| A simple downcast check. More...
bool | is_overall_hidden () const
bool | is_scene_root () const
| Returns true if this particular node is known to be the render root of some active DisplayRegion associated with the global GraphicsEngine, false otherwise. More...
bool | is_under_scene_root () const
| Returns true if this particular node is in a live scene graph: that is, it is a child or descendent of a node that is itself a scene root. More...
void | list_tags (std::ostream &out, const std::string &separator="\n") const
| Writes a list of all the tag keys assigned to the node to the indicated stream. More...
void | ls (std::ostream &out, int indent_level) const
void | mark_bounds_stale (Thread *current_thread=Thread::get_current_thread()) const
void | mark_internal_bounds_stale (Thread *current_thread=Thread::get_current_thread())
virtual void | output (std::ostream &out) const
void | prepare_scene (GraphicsStateGuardianBase *gsg, const RenderState *node_state)
virtual bool | preserve_name () const
| Returns true if the node's name has extrinsic meaning and must be preserved across a flatten operation, false otherwise. More...
| PT (PandaNode) copy_subgraph(Thread *current_thread
void | remove_all_children (Thread *current_thread=Thread::get_current_thread())
| Removes all the children from the node at once, including stashed children. More...
void | remove_child (int child_index, Thread *current_thread=Thread::get_current_thread())
| Removes the nth child from the node. More...
bool | remove_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Removes the indicated child from the node. More...
void | remove_stashed (int child_index, Thread *current_thread=Thread::get_current_thread())
| Removes the nth stashed child from the node. More...
bool | replace_child (PandaNode *orig_child, PandaNode *new_child, Thread *current_thread=Thread::get_current_thread())
| Searches for the orig_child node in the node's list of children, and replaces it with the new_child instead. More...
void | replace_node (PandaNode *other)
| Inserts this node into the scene graph in place of the other one, and removes the other node. More...
void | reset_prev_transform (Thread *current_thread=Thread::get_current_thread())
| Resets the transform that represents this node's "previous" position to the same as the current transform. More...
virtual bool | safe_to_combine () const
| Returns true if it is generally safe to combine this particular kind of PandaNode with other kinds of PandaNodes of compatible type, adding children or whatever. More...
virtual bool | safe_to_combine_children () const
| Returns true if it is generally safe to combine the children of this PandaNode with each other. More...
virtual bool | safe_to_flatten () const
| Returns true if it is generally safe to flatten out this particular kind of PandaNode by duplicating instances (by calling dupe_for_flatten()), false otherwise (for instance, a Camera cannot be safely flattened, because the Camera pointer itself is meaningful). More...
virtual bool | safe_to_flatten_below () const
| Returns true if a flatten operation may safely continue past this node, or false if nodes below this node may not be molested. More...
virtual bool | safe_to_modify_transform () const
| Returns true if it is safe to automatically adjust the transform on this kind of node. More...
virtual bool | safe_to_transform () const
| Returns true if it is generally safe to transform this particular kind of PandaNode by calling the xform() method, false otherwise. More...
void | set_attrib (const RenderAttrib *attrib, int override=0)
| Adds the indicated render attribute to the scene graph on this node. More...
void | set_bound (const BoundingVolume *volume)
| Deprecated. More...
void | set_bounds (const BoundingVolume *volume)
| Resets the bounding volume so that it is the indicated volume. More...
void | set_bounds_type (BoundingVolume::BoundsType bounds_type)
| Specifies the desired type of bounding volume that will be created for this node. More...
void | set_effect (const RenderEffect *effect)
| Adds the indicated render effect to the scene graph on this node. More...
void | set_effects (const RenderEffects *effects, Thread *current_thread=Thread::get_current_thread())
void | set_final (bool flag)
void | set_into_collide_mask (CollideMask mask)
void | set_overall_hidden (bool overall_hidden)
void | set_prev_transform (const TransformState *transform, Thread *current_thread=Thread::get_current_thread())
| Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations. More...
void | set_state (const RenderState *state, Thread *current_thread=Thread::get_current_thread())
void | set_tag (const std::string &key, const std::string &value, Thread *current_thread=Thread::get_current_thread())
void | set_transform (const TransformState *transform, Thread *current_thread=Thread::get_current_thread())
void | set_unexpected_change (unsigned int flags)
| Sets one or more of the PandaNode::UnexpectedChange bits on, indicating that the corresponding property should not change again on this node. More...
void | stash_child (int child_index, Thread *current_thread=Thread::get_current_thread())
| Stashes the indicated child node. More...
bool | stash_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Stashes the indicated child node. More...
void | steal_children (PandaNode *other, Thread *current_thread=Thread::get_current_thread())
| Moves all the children from the other node onto this node. More...
void | unstash_child (int stashed_index, Thread *current_thread=Thread::get_current_thread())
| Returns the indicated stashed node to normal child status. More...
bool | unstash_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Returns the indicated stashed node to normal child status. More...
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates. More...
virtual void | write (std::ostream &out, int indent_level) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file. More...
void | write_recorder (BamWriter *manager, Datagram &dg)
| This method is provided for the benefit of classes (like MouseRecorder) that inherit from PandaMode and also RecorderBase. More...
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type. More...
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin(). More...
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object. More...
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string. More...
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed. More...
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter. More...
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams. More...
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed. More...
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object. More...
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise. More...
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack. More...
void | ref () const
| Explicitly increments the reference count. More...
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero. More...
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus. More...
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus. More...
virtual bool | unref () const
| Explicitly decrements the reference count. More...
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one. More...
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object. More...
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object. More...
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty. More...
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty. More...
void | output (std::ostream &out) const
| Outputs the Namable. More...
void | set_name (const std::string &name)

## Static Public Member Functions
static void | background_candidate (const MouseWatcherParameter &param)
| Calls candidate() on all the PGItems with background focus. More...
static void | background_keystroke (const MouseWatcherParameter &param)
| Calls keystroke() on all the PGItems with background focus. More...
static void | background_press (const MouseWatcherParameter &param)
| Calls press() on all the PGItems with background focus. More...
static void | background_release (const MouseWatcherParameter &param)
| Calls release() on all the PGItems with background focus. More...
static TypeHandle | get_class_type ()
static std::string | get_enter_prefix ()
| Returns the prefix that is used to define the enter event for all PGItems. More...
static std::string | get_exit_prefix ()
| Returns the prefix that is used to define the exit event for all PGItems. More...
static std::string | get_focus_in_prefix ()
| Returns the prefix that is used to define the focus_in event for all PGItems. More...
static PGItem * | get_focus_item ()
| Returns the one PGItem in the world that currently has keyboard focus, if any, or NULL if no item has keyboard focus. More...
static std::string | get_focus_out_prefix ()
| Returns the prefix that is used to define the focus_out event for all PGItems. More...
static std::string | get_keystroke_prefix ()
| Returns the prefix that is used to define the keystroke event for all PGItems. More...
static std::string | get_press_prefix ()
| Returns the prefix that is used to define the press event for all PGItems. More...
static std::string | get_release_prefix ()
| Returns the prefix that is used to define the release event for all PGItems. More...
static std::string | get_repeat_prefix ()
| Returns the prefix that is used to define the repeat event for all PGItems. More...
static TextNode * | get_text_node ()
| Returns the TextNode object that will be used by all PGItems to generate default labels given a string. More...
static std::string | get_within_prefix ()
| Returns the prefix that is used to define the within event for all PGItems. More...
static std::string | get_without_prefix ()
| Returns the prefix that is used to define the without event for all PGItems. More...
static void | init_type ()
static void | set_text_node (TextNode *node)
| Changes the TextNode object that will be used by all PGItems to generate default labels given a string. More...
Static Public Member Functions inherited from PandaNode
static DrawMask | get_all_camera_mask ()
static TypeHandle | get_class_type ()
static DrawMask | get_overall_bit ()
static void | init_type ()
static | PT (PandaNode) decode_from_bam_stream(vector_uchar data
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type PandaNode. More...
static void | reset_all_prev_transform (Thread *current_thread=Thread::get_current_thread())
| Visits all nodes in the world with the _dirty_prev_transform flag–that is, all nodes whose _prev_transform is different from the _transform in pipeline stage 0–and resets the _prev_transform to be the same as _transform. More...
static void | set_scene_root_func (SceneRootFunc *func)
| This is used by the GraphicsEngine to hook in a pointer to the scene_root_func(), the function to determine whether the node is an active scene root. More...
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes. More...
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
| get_num_state_defs
| Returns one more than the highest-numbered state def that was ever assigned to the PGItem. More...
| get_state_def
| Returns the Node that is the root of the subgraph that will be drawn when the PGItem is in the indicated state. More...
Public Attributes inherited from PandaNode
| clear_tag
| Removes the value defined for this key on this particular node. More...
virtual LPoint3 bool const TransformState Thread * | current_thread = Thread::get_current_thread()) const
Thread * | current_thread = Thread::get_current_thread()) const
virtual LPoint3 bool & | found_any
| get_all_camera_mask
| Returns a DrawMask that is appropriate for rendering to all cameras. More...
| get_bounds_type
| Returns the bounding volume type set with set_bounds_type(). More...
| get_child
| Returns the nth child node of this node. More...
| get_children
| Returns an object that can be used to walk through the list of children of the node. More...
| get_draw_control_mask
| Returns the set of bits in draw_show_mask that are considered meaningful. More...
| get_draw_show_mask
| Returns the hide/show bits of this particular node. More...
| get_effects
| get_internal_bounds
| get_internal_vertices
| get_into_collide_mask
| Returns the "into" collide mask for this node. More...
| get_legal_collide_mask
| Returns the subset of CollideMask bits that may be set for this particular type of PandaNode. More...
| get_nested_vertices
| get_num_children
| Returns the number of child nodes this node has. More...
| get_num_parents
| Returns the number of parent nodes this node has. More...
| get_num_stashed
| Returns the number of stashed nodes this node has. More...
| get_num_tags
| get_overall_bit
| get_parent
| Returns the nth parent node of this node. More...
| get_parents
| Returns an object that can be used to walk through the list of parents of the node, similar to get_children() and get_stashed(). More...
| get_prev_transform
| get_python_tags
| get_stashed
| Returns the nth stashed child of this node. More...
| get_state
| get_tag
| get_tag_key
| get_transform
| has_tag
| is_bounds_stale
| is_final
| Returns the current state of the "final" flag. More...
| is_overall_hidden
| Returns true if the node has been hidden to all cameras by clearing its overall bit. More...
virtual LPoint3 & | max_point
static BamReader * | reader = nullptr)
| set_effects
| Sets the complete RenderEffects that will be applied this node. More...
| set_final
| set_into_collide_mask
| Sets the "into" CollideMask. More...
| set_overall_hidden
| Sets or clears the hidden flag. More...
| set_state
| Sets the complete RenderState that will be applied to all nodes at this level and below. More...
| set_tag
| Associates a user-defined value with a user-defined key which is stored on the node. More...
| set_transform
| Sets the transform that will be applied to this node and below. More...
virtual LPoint3 bool const TransformState * | transform
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count. More...
Public Attributes inherited from Namable
| get_name
| set_name

## Additional Inherited Members
Public Types inherited from PandaNode
enum | FancyBits { FB_transform = 0x0001 , FB_state = 0x0002 , FB_effects = 0x0004 , FB_tag = 0x0010 , FB_draw_mask = 0x0020 , FB_cull_callback = 0x0040 }
typedef bool | SceneRootFunc(const PandaNode *)
enum | UnexpectedChange { UC_parents = 0x001 , UC_children = 0x002 , UC_transform = 0x004 , UC_state = 0x008 , UC_draw_mask = 0x010 }
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This is the base class for all the various kinds of gui widget objects.

It is a Node which corresponds to a rectangular region on the screen, and it may have any number of "state" subgraphs, one of which is rendered at any given time according to its current state.

The PGItem node must be parented to the scene graph somewhere beneath a PGTop node in order for this behavior to work.

Definition at line 53 of file pgItem.h.

## Member Function Documentation

## ◆ background_candidate()

void PGItem::background_candidate | ( | const MouseWatcherParameter & | param | ) |
| static

Calls candidate() on all the PGItems with background focus.

Definition at line 821 of file pgItem.cxx.

Referenced by PGMouseWatcherBackground::candidate().

## ◆ background_keystroke()

void PGItem::background_keystroke | ( | const MouseWatcherParameter & | param | ) |
| static

Calls keystroke() on all the PGItems with background focus.

Definition at line 809 of file pgItem.cxx.

Referenced by PGMouseWatcherBackground::keystroke().

## ◆ background_press()

void PGItem::background_press | ( | const MouseWatcherParameter & | param | ) |
| static

Calls press() on all the PGItems with background focus.

Definition at line 785 of file pgItem.cxx.

Referenced by PGMouseWatcherBackground::press().

## ◆ background_release()

void PGItem::background_release | ( | const MouseWatcherParameter & | param | ) |
| static

Calls release() on all the PGItems with background focus.

Definition at line 797 of file pgItem.cxx.

Referenced by PGMouseWatcherBackground::release().

## ◆ candidate()

void PGItem::candidate | ( | const MouseWatcherParameter & | param,
|  | bool | background
| ) |  |
| virtual

This is a callback hook function, called whenever the user highlights an option in the IME window.

Reimplemented in PGEntry.

Definition at line 749 of file pgItem.cxx.

References get_notify(), and has_notify().

Referenced by PGMouseWatcherRegion::candidate(), and PGEntry::candidate().

## ◆ clear_frame()

void PGItem::clear_frame | ( |  | ) |
| inline

Removes the bounding rectangle from the item.

It will no longer be possible to position the mouse within the item; see set_frame().

Definition at line 125 of file pgItem.I.

## ◆ clear_state_def()

void PGItem::clear_state_def | ( | int | state | ) |

Resets the NodePath assigned to the indicated state to its initial default, with only a frame representation if appropriate.

Definition at line 952 of file pgItem.cxx.

References Pipeline::get_render_pipeline().

Referenced by PGButton::setup(), PGVirtualFrame::setup(), PGScrollFrame::setup(), PGWaitBar::setup(), PGSliderBar::setup_scroll_bar(), and PGSliderBar::setup_slider().

## ◆ enter_region()

void PGItem::enter_region | ( | const MouseWatcherParameter & | param | ) |
| virtual

This is a callback hook function, called whenever the mouse enters the region.

The mouse is only considered to be "entered" in one region at a time; in the case of nested regions, it exits the outer region before entering the inner one.

Reimplemented in PGButton.

Definition at line 537 of file pgItem.cxx.

References get_enter_event().

Referenced by PGButton::enter_region(), and PGMouseWatcherRegion::enter_region().

## ◆ exit_region()

void PGItem::exit_region | ( | const MouseWatcherParameter & | param | ) |
| virtual

This is a callback hook function, called whenever the mouse exits the region.

The mouse is only considered to be "entered" in one region at a time; in the case of nested regions, it exits the outer region before entering the inner one.

Reimplemented in PGButton.

Definition at line 561 of file pgItem.cxx.

References get_exit_event().

Referenced by PGButton::exit_region(), and PGMouseWatcherRegion::exit_region().

## ◆ focus_in()

void PGItem::focus_in | ( |  | ) |
| virtual

This is a callback hook function, called whenever the widget gets the keyboard focus.

Definition at line 631 of file pgItem.cxx.

References get_focus_in_event().

Referenced by set_focus().

## ◆ focus_out()

void PGItem::focus_out | ( |  | ) |
| virtual

This is a callback hook function, called whenever the widget loses the keyboard focus.

Definition at line 652 of file pgItem.cxx.

References get_focus_out_event().

Referenced by set_focus().

## ◆ get_active()

bool PGItem::get_active | ( |  | ) | const
| inline

Returns whether the PGItem is currently active for mouse events.

See set_active().

Definition at line 159 of file pgItem.I.

Referenced by PGEntry::candidate(), PGButton::enter_region(), PGButton::exit_region(), PGEntry::keystroke(), PGButton::press(), PGEntry::press(), PGSliderBar::press(), PGButton::release(), PGButton::set_active(), and set_focus().

## ◆ get_background_focus()

bool PGItem::get_background_focus | ( |  | ) | const
| inline

Returns whether background_focus is currently enabled.

See set_background_focus().

Definition at line 179 of file pgItem.I.

Referenced by PGEntry::press(), and set_background_focus().

## ◆ get_enter_event()

std::string PGItem::get_enter_event | ( |  | ) | const
| inline

Returns the event name that will be thrown when the item is active and the mouse enters its frame, but not any nested frames.

Definition at line 348 of file pgItem.I.

Referenced by enter_region().

## ◆ get_enter_prefix()

std::string PGItem::get_enter_prefix | ( |  | ) |
| inline static

Returns the prefix that is used to define the enter event for all PGItems.

The enter event is the concatenation of this string followed by get_id().

Definition at line 247 of file pgItem.I.

## ◆ get_exit_event()

std::string PGItem::get_exit_event | ( |  | ) | const
| inline

Returns the event name that will be thrown when the item is active and the mouse exits its frame, or enters a nested frame.

Definition at line 358 of file pgItem.I.

Referenced by exit_region().

## ◆ get_exit_prefix()

std::string PGItem::get_exit_prefix | ( |  | ) |
| inline static

Returns the prefix that is used to define the exit event for all PGItems.

The exit event is the concatenation of this string followed by get_id().

Definition at line 256 of file pgItem.I.

## ◆ get_focus()

bool PGItem::get_focus | ( |  | ) | const
| inline

Returns whether the PGItem currently has focus for keyboard events.

See set_focus().

Definition at line 169 of file pgItem.I.

Referenced by PGEntry::press(), PGButton::release(), set_active(), and set_focus().

## ◆ get_focus_in_event()

std::string PGItem::get_focus_in_event | ( |  | ) | const
| inline

Returns the event name that will be thrown when the item gets the keyboard focus.

Definition at line 392 of file pgItem.I.

Referenced by focus_in().

## ◆ get_focus_in_prefix()

std::string PGItem::get_focus_in_prefix | ( |  | ) |
| inline static

Returns the prefix that is used to define the focus_in event for all PGItems.

The focus_in event is the concatenation of this string followed by get_id().

Unlike most item events, this event is thrown with no parameters.

Definition at line 287 of file pgItem.I.

## ◆ get_focus_item()

PGItem * PGItem::get_focus_item | ( |  | ) |
| inline static

Returns the one PGItem in the world that currently has keyboard focus, if any, or NULL if no item has keyboard focus.

Use PGItem::set_focus() to activate or deactivate keyboard focus on a particular item.

Definition at line 466 of file pgItem.I.

## ◆ get_focus_out_event()

std::string PGItem::get_focus_out_event | ( |  | ) | const
| inline

Returns the event name that will be thrown when the item loses the keyboard focus.

Definition at line 402 of file pgItem.I.

Referenced by focus_out().

## ◆ get_focus_out_prefix()

std::string PGItem::get_focus_out_prefix | ( |  | ) |
| inline static

Returns the prefix that is used to define the focus_out event for all PGItems.

The focus_out event is the concatenation of this string followed by get_id().

Unlike most item events, this event is thrown with no parameters.

Definition at line 299 of file pgItem.I.

## ◆ get_frame()

const LVecBase4 & PGItem::get_frame | ( |  | ) | const
| inline

Returns the bounding rectangle of the item.

See set_frame(). It is an error to call this if has_frame() returns false.

Definition at line 105 of file pgItem.I.

Referenced by PGSliderBar::recompute(), PGScrollFrame::remanage(), and PGSliderBar::remanage().

## ◆ get_frame_inv_xform()

LMatrix4 PGItem::get_frame_inv_xform | ( |  | ) | const
| inline

Returns the inverse of the frame transform matrix.

Definition at line 474 of file pgItem.I.

## ◆ get_frame_style()

PGFrameStyle PGItem::get_frame_style | ( | int | state | ) |

Returns the kind of frame that will be drawn behind the item when it is in the indicated state.

Definition at line 993 of file pgItem.cxx.

Referenced by PGScrollFrame::remanage().

## ◆ get_id()

const std::string & PGItem::get_id | ( |  | ) | const
| inline

Returns the unique ID assigned to this PGItem.

This will be assigned to the region created with the MouseWatcher, and will thus be used to generate event names.

Definition at line 223 of file pgItem.I.

## ◆ get_keystroke_event()

std::string PGItem::get_keystroke_event | ( |  | ) | const
| inline

Returns the event name that will be thrown when the item is active and any key is pressed by the user.

Definition at line 445 of file pgItem.I.

Referenced by keystroke().

## ◆ get_keystroke_prefix()

std::string PGItem::get_keystroke_prefix | ( |  | ) |
| inline static

Returns the prefix that is used to define the keystroke event for all PGItems.

The keystroke event is the concatenation of this string followed by a hyphen and get_id().

Definition at line 339 of file pgItem.I.

## ◆ get_notify()

PGItemNotify * PGItem::get_notify | ( |  | ) | const
| inline

Returns the object which will be notified when the PGItem changes, if any.

Returns NULL if there is no such object configured.

Definition at line 68 of file pgItem.I.

Referenced by candidate().

## ◆ get_press_event()

std::string PGItem::get_press_event | ( | const ButtonHandle & | button | ) | const
| inline

Returns the event name that will be thrown when the item is active and the indicated mouse or keyboard button is depressed while the mouse is within the frame.

Definition at line 413 of file pgItem.I.

Referenced by press().

## ◆ get_press_prefix()

std::string PGItem::get_press_prefix | ( |  | ) |
| inline static

Returns the prefix that is used to define the press event for all PGItems.

The press event is the concatenation of this string followed by a button name, followed by a hyphen and get_id().

Definition at line 309 of file pgItem.I.

## ◆ get_region()

PGMouseWatcherRegion * PGItem::get_region | ( |  | ) | const
| inline

Returns the MouseWatcherRegion associated with this item.

Every PGItem has a MouseWatcherRegion associated with it, that is created when the PGItem is created; it does not change during the lifetime of the PGItem. Even items that do not have a frame have an associated MouseWatcherRegion, although it will not be used in this case.

Definition at line 30 of file pgItem.I.

## ◆ get_release_event()

std::string PGItem::get_release_event | ( | const ButtonHandle & | button | ) | const
| inline

Returns the event name that will be thrown when the item is active and the indicated mouse or keyboard button, formerly clicked down is within the frame, is released.

Definition at line 435 of file pgItem.I.

Referenced by release().

## ◆ get_release_prefix()

std::string PGItem::get_release_prefix | ( |  | ) |
| inline static

Returns the prefix that is used to define the release event for all PGItems.

The release event is the concatenation of this string followed by a button name, followed by a hyphen and get_id().

Definition at line 329 of file pgItem.I.

## ◆ get_repeat_event()

std::string PGItem::get_repeat_event | ( | const ButtonHandle & | button | ) | const
| inline

Returns the event name that will be thrown when the item is active and the indicated mouse or keyboard button is continuously held down while the mouse is within the frame.

Definition at line 424 of file pgItem.I.

Referenced by press().

## ◆ get_repeat_prefix()

std::string PGItem::get_repeat_prefix | ( |  | ) |
| inline static

Returns the prefix that is used to define the repeat event for all PGItems.

The repeat event is the concatenation of this string followed by a button name, followed by a hyphen and get_id().

Definition at line 319 of file pgItem.I.

## ◆ get_state()

int PGItem::get_state | ( |  | ) | const
| inline

Returns the "state" of this particular PGItem.

See set_state().

Definition at line 149 of file pgItem.I.

Referenced by PGScrollFrame::remanage().

## ◆ get_suppress_flags()

int PGItem::get_suppress_flags | ( |  | ) | const
| inline

This is just an interface to get the suppress flags on the underlying MouseWatcherRegion.

See MouseWatcherRegion::get_suppress_flags().

Definition at line 199 of file pgItem.I.

## ◆ get_text_node()

TextNode * PGItem::get_text_node | ( |  | ) |
| static

Returns the TextNode object that will be used by all PGItems to generate default labels given a string.

This can be loaded with the default font, etc.

Definition at line 1078 of file pgItem.cxx.

Referenced by PGEntry::get_text_def(), and PGButton::setup().

## ◆ get_within_event()

std::string PGItem::get_within_event | ( |  | ) | const
| inline

Returns the event name that will be thrown when the item is active and the mouse moves within the boundaries of the frame.

This is different from the enter_event in that the mouse is considered within the frame even if it is also within a nested frame.

Definition at line 370 of file pgItem.I.

Referenced by within_region().

## ◆ get_within_prefix()

std::string PGItem::get_within_prefix | ( |  | ) |
| inline static

Returns the prefix that is used to define the within event for all PGItems.

The within event is the concatenation of this string followed by get_id().

Definition at line 265 of file pgItem.I.

## ◆ get_without_event()

std::string PGItem::get_without_event | ( |  | ) | const
| inline

Returns the event name that will be thrown when the item is active and the mouse moves completely outside the boundaries of the frame.

This is different from the exit_event in that the mouse is considered within the frame even if it is also within a nested frame.

Definition at line 382 of file pgItem.I.

Referenced by without_region().

## ◆ get_without_prefix()

std::string PGItem::get_without_prefix | ( |  | ) |
| inline static

Returns the prefix that is used to define the without event for all PGItems.

The without event is the concatenation of this string followed by get_id().

Definition at line 275 of file pgItem.I.

## ◆ has_frame()

bool PGItem::has_frame | ( |  | ) | const
| inline

Returns true if the item has a bounding rectangle; see set_frame().

Definition at line 115 of file pgItem.I.

Referenced by PGSliderBar::recompute().

## ◆ has_notify()

bool PGItem::has_notify | ( |  | ) | const
| inline

Returns true if there is an object configured to be notified when the PGItem changes, false otherwise.

Definition at line 58 of file pgItem.I.

Referenced by candidate().

## ◆ has_state_def()

bool PGItem::has_state_def | ( | int | state | ) | const

Returns true if get_state_def() has ever been called for the indicated state (thus defining a render subgraph for this state index), false otherwise.

Definition at line 939 of file pgItem.cxx.

## ◆ instance_to_state_def()

NodePath PGItem::instance_to_state_def | ( | int | state,
|  | const NodePath & | path
| ) |  |

Parents an instance of the bottom node of the indicated NodePath to the indicated state index.

Definition at line 976 of file pgItem.cxx.

References NodePath::instance_to(), and NodePath::is_empty().

Referenced by PGButton::setup().

## ◆ keystroke()

void PGItem::keystroke | ( | const MouseWatcherParameter & | param,
|  | bool | background
| ) |  |
| virtual

This is a callback hook function, called whenever the user presses a key.

Reimplemented in PGEntry.

Definition at line 725 of file pgItem.cxx.

References get_keystroke_event().

Referenced by PGMouseWatcherRegion::keystroke(), and PGEntry::keystroke().

## ◆ move()

void PGItem::move | ( | const MouseWatcherParameter & | param | ) |
| virtual

This is a callback hook function, called whenever a mouse is moved while within the region.

Reimplemented in PGSliderBar.

Definition at line 769 of file pgItem.cxx.

Referenced by PGMouseWatcherRegion::move().

## ◆ press()

void PGItem::press | ( | const MouseWatcherParameter & | param,
|  | bool | background
| ) |  |
| virtual

This is a callback hook function, called whenever a mouse or keyboard button is depressed while the mouse is within the region.

Reimplemented in PGSliderBar, PGEntry, and PGButton.

Definition at line 673 of file pgItem.cxx.

References MouseWatcherParameter::get_button(), get_press_event(), get_repeat_event(), and MouseWatcherParameter::is_keyrepeat().

Referenced by PGMouseWatcherRegion::press(), PGButton::press(), and PGEntry::press().

## ◆ release()

void PGItem::release | ( | const MouseWatcherParameter & | param,
|  | bool | background
| ) |  |
| virtual

This is a callback hook function, called whenever a mouse or keyboard button previously depressed with press() is released.

Reimplemented in PGSliderBar, and PGButton.

Definition at line 702 of file pgItem.cxx.

References MouseWatcherParameter::get_button(), and get_release_event().

Referenced by PGMouseWatcherRegion::release(), PGButton::release(), and PGSliderBar::release().

## ◆ set_active()

void PGItem::set_active | ( | bool | active | ) |
| virtual

Sets whether the PGItem is active for mouse watching.

This is not necessarily related to the active/inactive appearance of the item, which is controlled by set_state(), but it does affect whether it responds to mouse events.

Reimplemented in PGSliderBar, PGEntry, and PGButton.

Definition at line 836 of file pgItem.cxx.

References get_focus(), and set_focus().

Referenced by PGButton::set_active(), PGEntry::set_active(), and PGSliderBar::set_active().

## ◆ set_background_focus()

void PGItem::set_background_focus | ( | bool | focus | ) |

Sets the background_focus flag for this item.

When background_focus is enabled, the item will receive keypress events even if it is not in focus; in fact, even if it is not onscreen. Unlike normal focus, many items may have background_focus simultaneously.

Definition at line 901 of file pgItem.cxx.

References get_background_focus().

## ◆ set_focus()

void PGItem::set_focus | ( | bool | focus | ) |
| virtual

Sets whether the PGItem currently has keyboard focus.

This simply means that the item may respond to keyboard events as well as to mouse events; precisely what this means is up to the individual item.

Only one PGItem in the world is allowed to have focus at any given time. Setting the focus on any other item automatically disables the focus from the previous item.

Reimplemented in PGEntry.

Definition at line 859 of file pgItem.cxx.

References focus_in(), focus_out(), get_active(), get_focus(), and set_focus().

Referenced by set_active(), PGEntry::set_focus(), and set_focus().

## ◆ set_frame() [1/2]

void PGItem::set_frame | ( | const LVecBase4 & | frame | ) |
| inline

Sets the bounding rectangle of the item, in local coordinates.

This is the region on screen within which the mouse will be considered to be within the item. Normally, it should correspond to the bounding rectangle of the visible geometry of the item.

Definition at line 91 of file pgItem.I.

## ◆ set_frame() [2/2]

void PGItem::set_frame | ( | PN_stdfloat | left,
|  | PN_stdfloat | right,
|  | PN_stdfloat | bottom,
|  | PN_stdfloat | top
| ) |  |
| inline

Sets the bounding rectangle of the item, in local coordinates.

This is the region on screen within which the mouse will be considered to be within the item. Normally, it should correspond to the bounding rectangle of the visible geometry of the item.

Definition at line 80 of file pgItem.I.

Referenced by PGButton::setup(), PGVirtualFrame::setup(), PGScrollFrame::setup(), PGWaitBar::setup(), PGSliderBar::setup_scroll_bar(), and PGSliderBar::setup_slider().

## ◆ set_frame_style()

void PGItem::set_frame_style | ( | int | state,
|  | const PGFrameStyle & | style
| ) |  |

Changes the kind of frame that will be drawn behind the item when it is in the indicated state.

Definition at line 1006 of file pgItem.cxx.

Referenced by PGButton::setup(), PGVirtualFrame::setup(), PGScrollFrame::setup(), PGWaitBar::setup(), PGSliderBar::setup_scroll_bar(), and PGSliderBar::setup_slider().

## ◆ set_id()

void PGItem::set_id | ( | const std::string & | id | ) |
| inline

Set the unique ID assigned to this PGItem.

It is the user's responsibility to ensure that this ID is unique.

Normally, this should not need to be called, as the PGItem will assign itself an ID when it is created, but this function allows the user to decide to redefine the ID to be something possibly more meaningful.

Definition at line 237 of file pgItem.I.

## ◆ set_notify()

void PGItem::set_notify | ( | PGItemNotify * | notify | ) |
| inline

Sets the object which will be notified when the PGItem changes.

Set this to NULL to disable this effect. The PGItem does not retain ownership of the pointer; it is your responsibility to ensure that the notify object does not destruct.

Definition at line 42 of file pgItem.I.

## ◆ set_state()

void PGItem::set_state | ( | int | state | ) |
| inline

Sets the "state" of this particular PGItem.

The PGItem node will render as if it were the subgraph assigned to the corresponding index via set_state_def().

Definition at line 140 of file pgItem.I.

## ◆ set_suppress_flags()

void PGItem::set_suppress_flags | ( | int | suppress_flags | ) |
| inline

This is just an interface to set the suppress flags on the underlying MouseWatcherRegion.

See MouseWatcherRegion::set_suppress_flags().

Definition at line 189 of file pgItem.I.

## ◆ set_text_node()

void PGItem::set_text_node | ( | TextNode * | node | ) |
| inline static

Changes the TextNode object that will be used by all PGItems to generate default labels given a string.

This can be loaded with the default font, etc.

Definition at line 456 of file pgItem.I.

## ◆ within_region()

void PGItem::within_region | ( | const MouseWatcherParameter & | param | ) |
| virtual

This is a callback hook function, called whenever the mouse moves within the boundaries of the region, even if it is also within the boundaries of a nested region.

This is different from "enter", which is only called whenever the mouse is within only that region.

Definition at line 587 of file pgItem.cxx.

References get_within_event().

Referenced by PGMouseWatcherRegion::within_region().

## ◆ without_region()

void PGItem::without_region | ( | const MouseWatcherParameter & | param | ) |
| virtual

This is a callback hook function, called whenever the mouse moves completely outside the boundaries of the region.

See within().

Definition at line 609 of file pgItem.cxx.

References get_without_event().

Referenced by PGMouseWatcherRegion::without_region().

## Member Data Documentation

## ◆ get_num_state_defs

int PGItem::get_num_state_defs

Returns one more than the highest-numbered state def that was ever assigned to the PGItem.

The complete set of state defs assigned may then be retrieved by indexing from 0 to (get_num_state_defs() - 1).

This is only an upper limit on the actual number of state defs, since there may be holes in the list.

Definition at line 135 of file pgItem.h.

## ◆ get_state_def

NodePath & PGItem::get_state_def
| inline

Returns the Node that is the root of the subgraph that will be drawn when the PGItem is in the indicated state.

The first time this is called for a particular state index, it may create the Node.

Definition at line 135 of file pgItem.h.

The documentation for this class was generated from the following files:

- panda/src/pgui/pgItem.h
- panda/src/pgui/pgItem.cxx
- panda/src/pgui/pgItem.I